/*  
 * Half-Life client-side generic hook engine.
 * Copyright (c) Vasily Pupkin (clientbot@narod.ru) 2000-2001
 * Copyright (c) Tim Yunaev (tim@lviv.gu.net) 2000-2001
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * NOTE:
 * GNU license doesn't cover Engine directory.
 * Content of Engine directory is copyrighted (c) 1999, 2000, by Valve LLC
 * and it is licensed under Valve's proprietary license (see original HL SDK).
 *
 * $Id: sprites.cpp,v 1.2 2001/07/16 11:23:11 vasily Exp $
 */

#include <windows.h>

#define MAX_SPRITES		500

static char * sprites[MAX_SPRITES];


void add_sprite (int id, const char * sprite)
{
	if ( id >= 0 && id < MAX_SPRITES )
		sprites[id] = strdup(sprite);
}


const char * sprite_lookup (int id)
{
	if ( id >= 0 && id < MAX_SPRITES && sprites[id] )
		return sprites[id];
	else
		return "unknown";
}

