#pragma once

typedef unsigned long uint32_t;
typedef unsigned char uint8_t;
typedef unsigned long int_least16_t;


//=======================================================================================
class SHA
{
public:
	SHA(){reset();}
	void reset();
	void feed(const uint8_t *data,unsigned int length);
	void finish();

    uint32_t hashes[5]; /* Message Digest  */

protected:
	void processMessageBlock();
	void padMessage();
    uint32_t Length_Low;            /* Message length in bits      */
    uint32_t Length_High;           /* Message length in bits      */
                               /* Index into message block array   */
    int_least16_t Message_Block_Index;
    uint8_t Message_Block[64];      /* 512-bit message blocks      */
    int Computed;               /* Is the digest computed?         */
    int Corrupted;             /* Is the message digest corrupted? */

};

