
#define SNAKE_FIELDS_X   35
#define SNAKE_FIELDS_Y   26

#undef CONTENT_EMPTY
#undef CONTENT_SNAKE
#undef CONTENT_WALL
#undef CONTENT_ITEM


class Snake
{
public:
	void frame();
	void command(const string& command);

protected:
	int  dir;     // 1=left, 2=right, 3=up, 4=down, 5=pause
	int  next_dir;
	bool visible;
	void setRunning(bool);
	void nextLevel();


	double run_starttime;
	bool   running; 
	int    score;

	double wait_time;

	int  level;
	void reset();
	void grow ();
	void placeNewItem();
	void addBody(int x, int y);

	enum { CONTENT_EMPTY, CONTENT_SNAKE=100, CONTENT_WALL=101, CONTENT_ITEM=102 };
	int playfield[SNAKE_FIELDS_X][SNAKE_FIELDS_Y];

	std::vector<DWORD> body; // high word: x, low word: y
	int head;

	bool dead;

public:
	Snake();

};

extern Snake snake;